> For the complete documentation index, see [llms.txt](https://docs.akenza.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.akenza.io/device-management/your-data-flow/device-type/device-type/downlink.md).

# Downlink

This page describes the specifications for downlinks

Downlink encoders are used to encode or "translate" a human-readable JSON object into a device-specific payload (e.g. JSON -> HEX payload).

The downlink encoder script follows a similar notation to uplink decoders, however it uses `emit('downlink', payload)` to execute a downlink.

Using the `downlink` emit type has no effect in uplink scripts and custom logic blocks will be ignored and not further processed.

Generally, Downlinks can only be created for LoRa, NB-IoT and MQTT Devices. Downlinks for HTTP and CoAP devices are not supported at this point.

## Output Format

### LoRa Downlinks

The object needs to have a pre-defined structure as shown below.

```typescript
{
    "port": 1, // needs to 0 or any other positive integer
    "confirmed": true, // used for confirmed downlinks and is optional, default false
    "payloadHex": "hex-string" // has to be a hex-string
}
```

If this specification is not followed, an error will be thrown during the forwarding of the downlink object to the LoRaWAN carrier.

### MQTT Downlinks

The object needs to have a pre-defined structure as shown below.

```typescript
{
    "topic": "string", // the MQTT topic
    "payload": {
        // object with any properties
    }
}
```

If this specification is not followed, an error will be thrown during the publishing of the downlink to the MQTT device.

## Example downlink encoder

```javascript
function asciiToHexString(input) {
  let output = "";

  for (let i = 0; i < input.length; i += 1) {
    output += input.charCodeAt(i).toString(16);
  }

  return output;
}

function consume(event) {
  const payload = asciiToHexString(event.payload.message);
  const port = event.port ? event.port : 1;
  const confirmed = event.confirmed ? event.confirmed : false;

  emit("downlink", { payloadHex: payload, port, confirmed });
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.akenza.io/device-management/your-data-flow/device-type/device-type/downlink.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
